var app = {
    initialize: function() {
        document.addEventListener('deviceready', this.onDeviceReady.bind(this), false);
    },
    onDeviceReady: function() {
        this.receivedEvent('deviceready');

        var deviece_token = "NO_TOKEN";

        cordova.plugins.firebase.messaging.getToken().then(function(token) {
        deviece_token = token;

        cordova.plugins.firebase.messaging.onMessage(function(payload) {
            console.log("New foreground FCM message: ", payload);
        });        

        cordova.plugins.firebase.messaging.onBackgroundMessage(function(payload) {
            console.log("New background FCM message: ", payload);
        });        

        cordova.plugins.firebase.messaging.requestPermission().then(function() {
            console.log("Push messaging is allowed");
        });        

    

        function uploadFile(fileurl) {            
            
            inAppBrowserRef.executeScript({
                code: "apploading();"
            },function(values){   
            });                             
            
            fileurl = fileurl.replace("file:","");            
            var ipaddr = localStorage.getItem('ADDR');
            if ( ipaddr.indexOf("https") < 0 ) {
                ipaddr = "http://" + ipaddr;
            }
            var fileURL = fileurl;

            var uri = encodeURI(ipaddr + "/img_upload_save_android.do");
            var options = new FileUploadOptions();
            options.fileKey = "file";
            options.fileName = fileURL.substr(fileURL.lastIndexOf('/')+1);
            options.mimeType = "text/plain";
            
            var headers = {'headerParam':'headerValue'};
            options.headers = headers;
            var ft = new FileTransfer();
            ft.upload(fileURL, uri, onSuccess, onError, options);
         
            function onSuccess(r) {
               

                inAppBrowserRef.executeScript({
                    code: "appunloading();"
                },function(values){   
                });                

               if ( r.response != null ) {
                
               var imgurl = r.response.replace(",","");
               imgurl = ipaddr + "/img/" + imgurl;
                inAppBrowserRef.executeScript({
                        code: "setPicture('" + imgurl + "');"
                },function(values){
                    
                });               

                }

            }         
            function onError(error) {

                inAppBrowserRef.executeScript({
                    code: "appunloading();"
                },function(values){   
                });                  

            }
             
         }        



        inAppBrowserRef = null;
        var url = null;        

        var onSuccess = function(position) {};
        function onError(error) {}    
        navigator.geolocation.getCurrentPosition(onSuccess, onError);                

        if ( localStorage.getItem('ADDR') != null && localStorage.getItem('ADDR') != ""  && localStorage.getItem('ADDR') != " " ) {
            var ipaddr = localStorage.getItem('ADDR');
            $("#ADDR").val(ipaddr);

            localStorage.setItem('ADDR',ipaddr);
            var protocol = "http://";       
            if ( ipaddr.indexOf("https") > -1 ) { protocol = ""; }                       
            url = protocol + ipaddr + "/?TOKEN=" + deviece_token;           
            var target = "_blank";
            var options = "fullscreen=yes,toolbar=no,zoom=no,location=no,footer=no";

            inAppBrowserRef = cordova.InAppBrowser.open(url, target, options);
            inAppBrowserRef.show();
        }        




        function onNfc(nfcEvent) {            
            if (inAppBrowserRef != undefined) {                
                var tag = nfcEvent.tag;				
				var tagId = nfc.bytesToHexString(tag.id);				
                var tagData = tagId;
				
				if (  tag.ndefMessage != null && tag.ndefMessage.length > 0 && tag.ndefMessage[0].payload != null  ) {
					tagData = nfc.bytesToString(tag.ndefMessage[0].payload).substring(3);
				}
				
                var obj = {};
                obj.id = tagId;
                obj.value = tagData;
                var rdata = JSON.stringify(obj);
				
                inAppBrowserRef.executeScript({
                    code: "setNFC('" + rdata + "');"
                },function(values){
                });                                      
            }
        }    
        function winnfc() {}    
        function failnfc(error) {}        
        nfc.addNdefListener(onNfc, winnfc, failnfc);        


        function webviewcheck() {

            if (inAppBrowserRef != undefined) {
                inAppBrowserRef.executeScript({
                        code: "getAppfunc();"
                },function(values){
                    
                    if ( values == "BARCODE" ) {
                        
                        $(".maindp1").hide();
                        $(".maindp2").show();
                        inAppBrowserRef.hide();

                        var settings = cordova.plugins.scanner.getDefaultSettings();

                        cordova.plugins.scanner.startScanning(
                          p_Result => {


                            inAppBrowserRef.executeScript({
                                        code: "setBarcode('" + p_Result + "');"
                             },function(values){
                                    
                             });

                            inAppBrowserRef.show();   
                                
                            setTimeout( function(){

                                $(".maindp1").show();
                                $(".maindp2").hide();                                
                    
                            }, 1500 );                             
    
                          }, 
                          p_Error => {

                            inAppBrowserRef.show();   
                                
                            setTimeout( function(){

                                $(".maindp1").show();
                                $(".maindp2").hide();                                
                    
                            }, 1500 );                             

                          }, 
                          settings
                        );                           

                    }


                    if ( values == "GPS" ) {                        
                        var onSuccessGPS = function(position) {
                            var Latitude = position.coords.latitude;
                            var Longitude = position.coords.longitude;
                            var Timestamp = position.timestamp;

                            var obj = {};
                            obj.Latitude = Latitude + "";
                            obj.Longitude = Longitude + "";
                            obj.Timestamp = Timestamp + "";

                            inAppBrowserRef.executeScript({
                                        code: "setGPS('" + JSON.stringify(obj) + "');"
                            },function(values){
                            });                             

                        };
                        function onErrorGPS(error) {}    
                        navigator.geolocation.getCurrentPosition(onSuccessGPS, onErrorGPS);
                    }

                    

                    if ( values == "MRESET" ) {
                        
                        inAppBrowserRef.hide();
                        $(".maindp1").show();
                        $(".maindp2").hide();                           

                    }

                    
                    if ( values == "RECORD" ) {
                        
                        var captureSuccess = function(mediaFiles) {};
                        var captureError = function(error) {};
                        navigator.device.capture.captureAudio(captureSuccess, captureError, {limit:1});                        
                        
                    }

                    if ( values == "PICTURE" ) {
                        

                        navigator.camera.getPicture(onPictureSuccess, onPictureFail, { quality: 100,
                            destinationType: Camera.DestinationType.FILE_URI });
                        
                        function onPictureSuccess(imageURI) {
                            uploadFile(imageURI);
                        }

                        function onPictureFail(message) { alert(message); }
                        

                    }                    

                    if ( values == "FLASH" ) {
                        
                        window.plugins.flashlight.toggle(
                            function() {}, // optional success callback
                            function() {}, // optional error callback
                            {intensity: 0.3} // optional as well, used on iOS when switching on
                          );                         
                        
                    }


                    if ( values == "CAMERA" ) {

                        function captureSuccess(mediaFiles) {}
                        function captureError(error) {}
                        navigator.device.capture.captureImage(captureSuccess, captureError, {limit:1});                          

                    }


                }
                );
            }

        }

        setInterval(function(){ 
            webviewcheck();
        }, 500);


        

        $("#ADDRCHK").click(function(){
            
            var ipaddr = $("#ADDR").val();

            if ( ipaddr != null && ipaddr != "" ) {
                
                localStorage.setItem('ADDR',ipaddr);
                var protocol = "http://";       
                if ( ipaddr.indexOf("https") > -1 ) { protocol = ""; }                       
                url = protocol + ipaddr + "/?TOKEN=" + deviece_token;           
                var target = "_blank";
                var options = "fullscreen=yes,toolbar=no,zoom=no,location=no,footer=no";

                inAppBrowserRef = cordova.InAppBrowser.open(url, target, options);
                inAppBrowserRef.show();

            } else {
                alert("Please enter address");              
            }
        });


  
        
        });  

    },

    receivedEvent: function(id) {
    }
};

app.initialize();
